# Copyright (c) 2005-2007 Forest Bond.
# This file is part of the sclapp software package.
# 
# sclapp is free software; you can redistribute it and/or modify it under the
# terms of the GNU General Public License version 2 as published by the Free
# Software Foundation.
# 
# A copy of the license has been included in the COPYING file.

import os, sys, signal, time, unittest
if '..' not in sys.path:
    sys.path = ['..'] + sys.path

__doc__ = '''
>>> import sclapp

>>> def myhandler(signum, frame):
...     print 'myhandler'

>>> sclapp.enableSignalHandling(
...   notify_signals = (signal.SIGINT,),
...   custom_handlers = {signal.SIGHUP: myhandler},
...   announce_signals = False
... )

>>> def f():
...     os.kill(os.getpid(), signal.SIGINT)
...     time.sleep(2)
>>> f()
Traceback (most recent call last):
...
SignalError: caught signal 2

>>> def f():
...     os.kill(os.getpid(), signal.SIGHUP)
...     time.sleep(2)
>>> f()
myhandler

>>> sclapp.disableSignalHandling()
'''

import common

common.defineDocTestCasesFromModule(__name__)
